<?php
/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/

require("../inc/stop_cache.php");
require("../inc/secure_page.php");
// connect to mysql
require("../../inc/dbconnect.php");
require("../inc/lang.php");
require("../../inc/config.php");
include("../inc/calendar.php");
include("../inc/rc4.php");

// Get passed-in vars
$nRecID = (isset($_GET['id']) ? $_GET['id'] : NULL);
if(!$nRecID){ $nRecID = (isset($_POST['id']) ? $_POST['id'] : NULL); }
$nEditMode = (isset($_GET['editMode']) ? $_GET['editMode'] : NULL);
if(!$nEditMode){ $nEditMode = (isset($_POST['editMode']) ? $_POST['editMode'] : NULL); }

// Additional security check if this account is a limited user (give only self access)
$nMyUserID = nGetUserIDFromName($ValidUser);
if(!$nAdminAccess && $nRecID!=$nMyUserID){ exit; }

// AJAX Specific vars
$nPassThru = "?id=$nRecID";
$nDivToUpdate = "ajaxUserEdit"; // must be same as parent edit page
$nPageInDiv = "edit/user.php";

// Get info
if($nRecID){
	$nSQL = "SELECT * FROM nEditor WHERE nID='$nRecID' LIMIT 1";
	mysql_select_db($DBName); $Result = mysql_query($nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"];
		$nUser = $Row["nUser"];
		$nPass = $Row["nPass"];
		$nEmail = $Row["nEmail"];
		//$nPass = rc4Decrypt("xyz123",$Row["nPass"]);
		$nAdmin = $Row["nAdmin"];
		$nUserLang = $Row["nUserLang"];
		switch($nUserLang){
			case "en": $nUserLangText = "English"; break;
			case "es": $nUserLangText = "Espa&ntilde;ol"; break;
			default:
				$nUserLangText = "";
				if($nDefaultLang){ $nUserLangText = nGetLangName($nDefaultLang); }
				break;
		}
		if($nAdmin){ $nAdminText = "<em>"._("Administrator")."</em>"; } else { $nAdminText = "<em>"._("Editor")."</em>"; }
		$nLoginDT = $Row["nLastLoginDate"];
		$nLoginDTARRAY = explode(" ",$nLoginDT);
		if($nLoginDT){
			$nDateDiff = nGetDateDiffDays($nLoginDTARRAY[0]);
			if($nDateDiff>0){ $nLoginDT = nDateToDisplayCustom($nLoginDTARRAY[0],"m/d/y"); } else { $nLoginDT = _("Today").", ".$nLoginDTARRAY[1]; }
		} else {
			$nLoginDT = "<span class=\"caption\"><em>&lt;"._("never")."&gt;</em></span>";
		}
		if(!$nUser){ $nUserText="<span class=\"caption\"><em>&lt;"._("unnamed")."&gt;</em></span>"; } else { $nUserText = $nUser; }
		if($nPass){ $nPassText = "********"; }
		if(!$nEmail){ $nEmailText="<span class=\"caption\"><em>&lt;"._("not set")."&gt;</em></span>"; } else { $nEmailText = $nEmail; }
	} else { echo "<div align=\"center\" style=\"padding:20px;\"><em>"._("No record found.")."</em></div>"; }
} else { echo "<div align=\"center\" style=\"padding:20px;\"><em>"._("No record available. Invalid ID.")."</em></div>"; }
?>

<?php if(!$nEditMode){ ?>

<div id="editBox">
	<div id="editBoxHdr"><span id="fieldGrpTitle"><?php echo _("Profile"); ?></span></div> 
	<div id="editBoxStatic">
		<table width="100%" border="0" cellspacing="0" cellpadding="0">
		  <tr>
			<td width="75" valign="top" style="padding-right:10px;"><img src="img/profile.gif" alt="" width="65" height="63" border="0"></td>
			<td valign="top" style="padding-right:40px;">
				<?php if($nUserText){ echo "<strong>"._("Username").":</strong> $nUserText<BR>"; } ?>
				<?php if($nPassText){ echo "<strong>"._("Password").":</strong> $nPassText<BR>"; } ?>
				<?php if($nEmailText){ echo "<strong>"._("E-mail").":</strong> $nEmailText<BR>"; } ?>
			</td>
			<td valign="top">
				<?php if($nUserLangText){ echo "<strong>"._("Language:")."</strong> $nUserLangText<BR>"; } ?>
				<?php if($nAdminText){ echo "<strong>"._("Access Level").":</strong> $nAdminText<BR>"; } ?>
				<BR>
				<?php if($nLoginDT){ echo "<span class=\"caption\"><strong>"._("Last Login").":</strong> $nLoginDT</span><BR>"; } ?>
			</td>
		  </tr>
		</table>
		<div style="clear:both;">&nbsp;</div>
		<div align="center" id="buttonBox">
			<input type="button" name="nEdit" value="<?php echo _("Edit"); ?>" class="formButton" onClick="loadContent('<?php echo $nDivToUpdate?>','<?php echo $nPageInDiv.$nPassThru?>&editMode=1');">
		</div>
	</div>
</div>
<?php } ?>

<?php if($nEditMode){ ?>
<div id="editBox">
<?php
include("../inc/form_class.php");

$nFormName = "FormUserEdit";
$nForm1 = new Form();
$nForm1->Name = $nFormName;
$nForm1->Action = $_SERVER['PHP_SELF'];
if($nRecID){
	$nForm1->SubmitText = _("Update");
	$nForm1->CancelText = _("Cancel");
	$nForm1->CancelRedirect = "loadContent('$nDivToUpdate','$nPageInDiv$nPassThru');";
	$nForm1->CancelRedirectIsJS = true;
	// Form DB settings
	$nForm1->ModifyDBTable = "nEditor";
	$nForm1->ModifyDBField = "nID";
	$nForm1->ModifyDBID = "'$nRecID'";
	$nForm1->DBLink = $Link;
	$nForm1->nUseADODB = false;
	// AJAX settings
	$nForm1->SubmitToJS = "return submitForm('$nDivToUpdate','$nPageInDiv$nPassThru',this.name);return false;";
}
$nForm1->DontProcess = "id,editMode";

// Create groups
$nFormGroup1 = new FormGroup();
$nFormGroup1->Name = _("Defaults");

// Create fields
$nFormField = new FormField("hidden","id");
$nFormField->Value = $nRecID;
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("hidden","editMode");
$nFormField->Value = "1";
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("text","nUser",_("Login Username:"));
$nFormField->Value = $nUser;
$nFormField->Caption = _("(max. 50 characters)");
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormField = $nForm1->AddValidation("minlength",$nFormField,4);
$nFormField = $nForm1->AddValidation("maxlength",$nFormField,50);
$nFormField->RowSize = "Half";
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("password","nPass",_("Login Password:"));
$nFormField->Value = $nPass;
$nFormField->Caption = _("(max. 16 characters)");
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormField = $nForm1->AddValidation("minlength",$nFormField,4);
$nFormField = $nForm1->AddValidation("maxlength",$nFormField,16);
//$nFormField = $nForm1->AddEncoding("RC4",$nFormField);
$nFormField->RowSize = "Half";
$nFormGroup1->AddField($nFormField);

if($nAdminAccess){
	$nFormField = new FormField("select","nAdmin",_("Access Level:"));
	$nEditorText = _("Editor");
	$nAdminText = _("Administrator");
	$nFormField->DataARRAY = array(
		"0" => $nEditorText,
		"1" => $nAdminText);
	if($nAdmin){ $nFormField->SelectedARRAY = array("1" => "selected"); }
	$nFormField->RowSize = "Half";
	$nFormField->Style = "width:200px;";
	$nFormField->RowStyle = "clear:both;float:none;";
	$nFormGroup1->AddField($nFormField);
}

$nFormField = new FormField("select","nUserLang",_("Language:"));
$nFormField->DataARRAY = array(
	"en" => "English",
	"es" => "Espa&ntilde;ol");
if($nUserLang){ $nFormField->SelectedARRAY = array("$nUserLang" => "selected"); }
$nFormField->RowSize = "Half";
$nFormField->Style = "width:200px;";
$nFormField->RowStyle = "clear:both;float:none;";
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("text","nEmail",_("E-mail Address:"));
$nFormField->Value = $nEmail;
$nFormField = $nForm1->AddValidation("email",$nFormField);
$nFormField = $nForm1->AddValidation("required",$nFormField);
$nFormField->RowSize = "Half";
$nFormField->Style = "width:428px;";
$nFormGroup1->AddField($nFormField);

// Finalize and display form
$nForm1->AddGroup($nFormGroup1);
$nFormToDisplay = $nForm1->GetForm();

// AJAX redirect if form submitted w/o error, otherwise display form (again, if necessary)
if($nForm1->HasProcessed){
	echo "<script>loadContent('$nDivToUpdate','$nPageInDiv$nPassThru');</script>";
} else {
	echo $nFormToDisplay;
}
?>
</div>
<?php } ?>
<?php
function nGetUserIDFromName($nUserName){
	global $DBName,$Link;
	if(!$nUserName){ return; }
	$Query = "SELECT nID FROM nEditor WHERE nUser='$nUserName' LIMIT 1";
	mysql_select_db($DBName); $Result = mysql_query($Query,$Link);
	if($Row = mysql_fetch_array($Result)) {
		$nUserID = $Row["nID"];
	}
	return $nUserID;
}
function nGetLangName($nLangCode){
	if(!$nLangCode){ return; }
	// Get lang file
	$path = "../../lang/def/$nLangCode.php";
	if(file_exists("$path")){ require("$path"); }
	return $nLang;
}
?>
<?php require("../../inc/db_close.php"); ?>
